program WEIfoc_
  !! Paul Sava (paul@sep.stanford.edu)
  !! 09/11/02
  !!
  !! Compute a focusing measure
  !! (i.e. derivative over space)
  !!
  !! input  mx-my-hx-hy-z
  !! output mx-my-hx-hy-z

  use sep
  use myax_

  implicit none

  logical     :: verb
  type(paxis) :: az,ahx,ahy,amx,amy
  integer     :: iz,ihx,ihy,imx,imy
  complex, dimension(:,:,:,:), allocatable ::idata,odata

  call sep_init()

  call from_param("verb",verb,.false.)

  call pinaxis(amx,1)
  call pinaxis(amy,2)
  call pinaxis(ahx,3)
  call pinaxis(ahy,4)
  call pinaxis(az ,5)

  call sep_close()

  allocate(idata(amx%n,amy%n,ahx%n,ahy%n))
  allocate(odata(amx%n,amy%n,ahx%n,ahy%n))

  odata = (0.,0.)

  do iz=1,az%n
     if(verb) write(0,*) iz,az%n
     call sep_read(idata)

     if(amx%n>1) then
        do imx=1,max(1,amx%n-1)
           odata(imx   ,:,:,:) = &
           odata(imx   ,:,:,:) + &
           idata(imx+1,:,:,:)-idata(imx,:,:,:)
        end do
     end if
     if(amy%n>1) then
        do imy=1,max(1,amy%n-1)
           odata( :,imy  ,:,:) = &
           odata( :,imy  ,:,:) + &
           idata(:,imy+1,:,:)-idata(:,imy,:,:)
        end do
     end if

     call sep_write(odata)
  end do

  deallocate(idata,odata)

  call exit(0)
end program WEIfoc_






